Subject: Re: bug#8368: 24.0.50; "temp" means "help" - rename or at least document

From: martin rudalics <[email-masked]>
Date: Tue, 01 May 2012 10:08:57 +0200

> IF a programmer wants a temp buffer without that help
 > stuff then s?he can do something like what I wrote, as a workaround: define a
 > macro that uses `w-o-t-t-b', but first removes the help-stuff hooks and restores
 > them afterward.  That's all.

S?he could also write such a macro from scratch and post the result here
together with a suitable name.

 > Your suggestion was IIUC to instead use `w-o-t-t-b' and just turn off help-mode
 > in the BODY.  OK, but that means that help-mode is entered and exited for
 > nothing - the hooks are run uselessly.

Who cares?  The overhead for removing and adding a hook (with all the
necessary protection) is just as high.

 > That's all I was pointing out.  Nothing
 > wrong with such useless work, but it, like my workaround, does not seem like the
 > solution to the problem.

We agree here.

 >> Obviously, dealing with `temp-buffer-show-hook' in
 >> `with-output-to-plain-temp-buffer' isn't necessary either if you don't
 >> run `help-mode-setup' before.
 >
 > Ah, yes.  Of course that means paying even more attention etc.
 >
 > Anyway, thanks for thinking about this.  I really would like to see Emacs fixed
 > in this regard.  To my mind (not having thought much about it, and being pretty
 > ignorant about it), I would think that inheritance could be used to factor out
 > the stuff that is not specifically for help mode (i.e., have the help-mode stuff
 > inherit from that).

That's the way to go, yes.  The question is rather one of how to avoid
confusing users when we have, for example, a `temp-buffer-setup-hook'
and a `plain-temp-buffer-setup-hook' and BOTH get run when we invoke the
inheriting macro.

martin